//---------------------------------------------------------------------------

#include <corbapch.h>
#pragma hdrstop

#include <corba.h>
#include "ServerServer.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)


ServerImpl::ServerImpl(const char *object_name):
        _sk_TPainter::_sk_Server(object_name)                 
{
 printf("Start server.\n");
 Actual=NULL;
 Anchor=NULL;
 Count=0;
}

CORBA::Long ServerImpl::Login(const char* _LogName,
  TPainter::Client_ptr _ObjRef)
{
 TClient *p1,*p2;
 p1=(TClient *)malloc(sizeof(TClient));

 if (Anchor!=NULL)
  {
   p2=Anchor;
   if (strcmp(Actual->Name,_LogName)==0)
    {
     delete (p1);
     return -1;
    }
   while (p2->Next!=NULL)
    {
     if (strcmp(p2->Name,_LogName)==0)
      {
       delete (p1);
       return -1;
      }
     p2=p2->Next;
    }
  }
 strcpy(p1->Name,_LogName);
 printf("Login of new Clinet: %s\n",p1->Name);
 p1->ObjRef=TPainter::Client::_duplicate(_ObjRef);
 p1->Next=NULL;
 p1->UAnchor=NULL;
 p1->UActual=NULL;
 p1->EAnchor=NULL;
 p1->EActual=NULL;
 if (Anchor==NULL) Anchor=p1;
 else
  {
   p2=Anchor;
   while (p2->Next!=NULL) { p2=p2->Next; }
   p2->Next=p1;
  }
 Actual=p1;
 Count=0;
 TClient *pcount;
 pcount=Anchor;
 while (pcount!=NULL)
  {
   _ObjRef->PrintClient(pcount->Name);
   Count++;
   pcount=pcount->Next;
  }
 pcount=Anchor;
 while (pcount!=NULL)
  {
   if (strcmp(pcount->Name,_LogName)!=0)
    pcount->ObjRef->AddNewClient(_LogName);
   pcount=pcount->Next;
  }
 return Count;
}

void ServerImpl::ClearAll(const char* _LogName)
{
 printf("Client [%s] clear all.\n",_LogName);
 TClient *c1;
 TUsers *u1;
 TElements *e1,*e2;
 c1=Anchor;
 while (c1!=NULL)
  {
   if (strcmp(c1->Name,_LogName)==0)
    {
     e1=c1->EAnchor;
     while (e1!=NULL)
      {
       e2=e1->Next;
       delete(e1);
       e1=e2;
      }
     c1->EAnchor=NULL;
     c1->EActual=NULL;
     break;
    }
   c1=c1->Next;
  }
 c1=Anchor;
 while (c1!=NULL)
  {
   if (strcmp(c1->Name,_LogName)==0)
    c1->ObjRef->ClearAll(_LogName);
   u1=c1->UAnchor;
   while (u1!=NULL)
    {
     if (strcmp(u1->Name,_LogName)==0)
      {
       c1->ObjRef->ClearAll(_LogName);
       break;
      }
     u1=u1->Next;
    }
   c1=c1->Next;
  }
}

void ServerImpl::LoadArea(const char* _LogName, const char* _Who)
{
 printf("Client [%s] load [%s].\n",_LogName,_Who);
 TClient *pcount;
 TElements *e1;
 TPainter::Client_ptr Act;
 pcount=Anchor;
 while (pcount!=NULL)
  {
   if (strcmp(pcount->Name,_LogName)==0)
    {
     Act=TPainter::Client::_duplicate(pcount->ObjRef);
     TUsers *u1,*u2;
     u1=(TUsers *)malloc(sizeof(TUsers));
     strcpy(u1->Name,_Who);
     u1->Next=NULL;
     if (pcount->UAnchor==NULL) pcount->UAnchor=u1;
     else
      {
       u2=pcount->UAnchor;
       while (u2->Next!=NULL) { u2=u2->Next; }
       u2->Next=u1;
      }
     pcount->UActual=u1;
     break;
    }
   pcount=pcount->Next;
  }
 pcount=Anchor;
 while (pcount!=NULL)
  {
   if (strcmp(pcount->Name,_Who)==0)
    {
     e1=pcount->EAnchor;
     while (e1!=NULL)
      {
       if (e1->Type==point)
         Act->PaintPoint(e1->x1,e1->y1,_Who);
       if (e1->Type==line)
        Act->PaintLine(e1->x1,e1->y1,e1->x2,e1->y2,_Who);
       if (e1->Type==rect)
        Act->PaintRect(e1->x1,e1->y1,e1->x2,e1->y2,_Who);
       if (e1->Type==circ)
        Act->PaintCirc(e1->x1,e1->y1,e1->x2,e1->y2,_Who);
       if (e1->Type==fill)
        Act->PaintFill(e1->x1,e1->y1,_Who);
       e1=e1->Next;
      }
     break; 
    }
   pcount=pcount->Next;
  }
}

void ServerImpl::Logout(const char* _LogName)
{
 printf("Logout of Client: %s\n",_LogName);
 TClient *p;
 p=Anchor;
 while (p->Next!=NULL)
  {
   if (strcmp(p->Name,_LogName)==0)
    {
     Actual=p;
     break;
    }
   p=p->Next;
  }
 if (Actual==Anchor)
  {
   Anchor=Actual->Next;
   delete(Actual);
   Actual=Anchor;
  }
 else
  {
   p=Anchor;
   while ((p!=NULL) && (p->Next!=Actual)) { p=p->Next; }
   p->Next=Actual->Next;
   delete(Actual);
   Actual=p;
  }
 Count=0;
 TClient *pcount;
 TUsers *u1,*u2;
 pcount=Anchor;
 while (pcount!=NULL)
  {
   Count++;
   u1=pcount->UAnchor;
   while (u1!=NULL)
    {
     if (strcmp(u1->Name,_LogName)==0)
      {
       pcount->ObjRef->CloseClient(_LogName);
       if (pcount->UActual==pcount->UAnchor)
        {
         pcount->UAnchor=pcount->UActual->Next;
         delete(pcount->UActual);
         pcount->UActual=pcount->UAnchor;
        }
       else
        {
         u2=pcount->UAnchor;
         while ((u2!=NULL) && (u2->Next!=pcount->UActual)) { u2=u2->Next; }
         u2->Next=pcount->UActual->Next;
         delete(pcount->UActual);
         pcount->UActual=u2;
        }
       break; 
      }
     u1=u1->Next;
    }
   pcount=pcount->Next;
  }
 if (Count==0)
  {
   Anchor=NULL;
   Actual=NULL;
  }
}

void ServerImpl::PaintCirc(CORBA::Short _x1, CORBA::Short _y1,
  CORBA::Short _x2, CORBA::Short _y2, const char* _LogName)
{
 printf("Client [%s] paint circle from [%d,%d] to [%d,%d].\n",_LogName,
        _x1,_y1,_x2,_y2);
 TClient *c1;
 TUsers *u1;
 c1=Anchor;
 while (c1!=NULL)
  {
   if (strcmp(c1->Name,_LogName)==0)
    {
     TElements *e1,*e2;
     e1=(TElements *)malloc(sizeof(TElements));
     e1->Type=circ;
     e1->x1=_x1;
     e1->y1=_y1;
     e1->x2=_x2;
     e1->y2=_y2;
     e1->Next=NULL;
     if (c1->EAnchor==NULL) c1->EAnchor=e1;
     else
      {
       e2=c1->EAnchor;
       while (e2->Next!=NULL) { e2=e2->Next; }
       e2->Next=e1;
      }
     c1->EActual=e1;
     break;
    }
   c1=c1->Next;
  }
 c1=Anchor;
 while (c1!=NULL)
  {
   if (strcmp(c1->Name,_LogName)==0)
    c1->ObjRef->PaintCirc(_x1,_y1,_x2,_y2,_LogName);
   u1=c1->UAnchor;
   while (u1!=NULL)
    {
     if (strcmp(u1->Name,_LogName)==0)
      {
       c1->ObjRef->PaintCirc(_x1,_y1,_x2,_y2,_LogName);
       break;
      }
     u1=u1->Next;
    }
   c1=c1->Next;
  }
}

void ServerImpl::PaintFill(CORBA::Short _x1, CORBA::Short _y1,
  const char* _LogName)
{
 printf("Client [%s] paint fill area [%d,%d].\n",_LogName,_x1,_y1);
 TClient *c1;
 TUsers *u1;
 c1=Anchor;
 while (c1!=NULL)
  {
   if (strcmp(c1->Name,_LogName)==0)
    {
     TElements *e1,*e2;
     e1=(TElements *)malloc(sizeof(TElements));
     e1->Type=fill;
     e1->x1=_x1;
     e1->y1=_y1;
     e1->Next=NULL;
     if (c1->EAnchor==NULL) c1->EAnchor=e1;
     else
      {
       e2=c1->EAnchor;
       while (e2->Next!=NULL) { e2=e2->Next; }
       e2->Next=e1;
      }
     c1->EActual=e1;
     break;
    }
   c1=c1->Next;
  }
 c1=Anchor;
 while (c1!=NULL)
  {
   if (strcmp(c1->Name,_LogName)==0)
    c1->ObjRef->PaintFill(_x1,_y1,_LogName);
   u1=c1->UAnchor;
   while (u1!=NULL)
    {
     if (strcmp(u1->Name,_LogName)==0)
      {
       c1->ObjRef->PaintFill(_x1,_y1,_LogName);
       break;
      }
     u1=u1->Next;
    }
   c1=c1->Next;
  }
}

void ServerImpl::PaintLine(CORBA::Short _x1, CORBA::Short _y1,
  CORBA::Short _x2, CORBA::Short _y2, const char* _LogName)
{
 printf("Client [%s] paint line from [%d,%d] to [%d,%d].\n",_LogName,
        _x1,_y1,_x2,_y2);
 TClient *c1;
 TUsers *u1;
 c1=Anchor;
 while (c1!=NULL)
  {
   if (strcmp(c1->Name,_LogName)==0)
    {
     TElements *e1,*e2;
     e1=(TElements *)malloc(sizeof(TElements));
     e1->Type=line;
     e1->x1=_x1;
     e1->y1=_y1;
     e1->x2=_x2;
     e1->y2=_y2;
     e1->Next=NULL;
     if (c1->EAnchor==NULL) c1->EAnchor=e1;
     else
      {
       e2=c1->EAnchor;
       while (e2->Next!=NULL) { e2=e2->Next; }
       e2->Next=e1;
      }
     c1->EActual=e1;
     break;
    }
   c1=c1->Next;
  }
 c1=Anchor;
 while (c1!=NULL)
  {
   if (strcmp(c1->Name,_LogName)==0)
    c1->ObjRef->PaintLine(_x1,_y1,_x2,_y2,_LogName);
   u1=c1->UAnchor;
   while (u1!=NULL)
    {
     if (strcmp(u1->Name,_LogName)==0)
      {
       c1->ObjRef->PaintLine(_x1,_y1,_x2,_y2,_LogName);
       break;
      }
     u1=u1->Next;
    }
   c1=c1->Next;
  }
}

void ServerImpl::PaintPoint(CORBA::Short _x1, CORBA::Short _y1,
  const char* _LogName)
{
 printf("Client [%s] paint point [%d,%d].\n",_LogName,_x1,_y1);
 TClient *c1;
 TUsers *u1;
 c1=Anchor;
 while (c1!=NULL)
  {
   if (strcmp(c1->Name,_LogName)==0)
    {
     TElements *e1,*e2;
     e1=(TElements *)malloc(sizeof(TElements));
     e1->Type=point;
     e1->x1=_x1;
     e1->y1=_y1;
     e1->Next=NULL;
     if (c1->EAnchor==NULL) c1->EAnchor=e1;
     else
      {
       e2=c1->EAnchor;
       while (e2->Next!=NULL) { e2=e2->Next; }
       e2->Next=e1;
      }
     c1->EActual=e1;
     break;
    }
   c1=c1->Next;
  }
 c1=Anchor;
 while (c1!=NULL)
  {
   if (strcmp(c1->Name,_LogName)==0)
    c1->ObjRef->PaintPoint(_x1,_y1,_LogName);
   u1=c1->UAnchor;
   while (u1!=NULL)
    {
     if (strcmp(u1->Name,_LogName)==0)
      {
       c1->ObjRef->PaintPoint(_x1,_y1,_LogName);
       break;
      }
     u1=u1->Next;
    }
   c1=c1->Next;
  }
}

void ServerImpl::PaintRect(CORBA::Short _x1, CORBA::Short _y1,
  CORBA::Short _x2, CORBA::Short _y2, const char* _LogName)
{
 printf("Client [%s] paint rectangle from [%d,%d] to [%d,%d].\n",_LogName,
        _x1,_y1,_x2,_y2);
 TClient *c1;
 TUsers *u1;
 c1=Anchor;
 while (c1!=NULL)
  {
   if (strcmp(c1->Name,_LogName)==0)
    {
     TElements *e1,*e2;
     e1=(TElements *)malloc(sizeof(TElements));
     e1->Type=rect;
     e1->x1=_x1;
     e1->y1=_y1;
     e1->x2=_x2;
     e1->y2=_y2;
     e1->Next=NULL;
     if (c1->EAnchor==NULL) c1->EAnchor=e1;
     else
      {
       e2=c1->EAnchor;
       while (e2->Next!=NULL) { e2=e2->Next; }
       e2->Next=e1;
      }
     c1->EActual=e1;
     break;
    }
   c1=c1->Next;
  }
 c1=Anchor;
 while (c1!=NULL)
  {
   if (strcmp(c1->Name,_LogName)==0)
    c1->ObjRef->PaintRect(_x1,_y1,_x2,_y2,_LogName);
   u1=c1->UAnchor;
   while (u1!=NULL)
    {
     if (strcmp(u1->Name,_LogName)==0)
      {
       c1->ObjRef->PaintRect(_x1,_y1,_x2,_y2,_LogName);
       break;
      }
     u1=u1->Next;
    }
   c1=c1->Next;
  }
}

void ServerImpl::SendTxt(const char* _txt, const char* _ToClient,
  const char* _FromClient)
{
 printf("Send message from [%s] to [%s].\n",_FromClient,_ToClient);
 TClient *c1;
 c1=Anchor;
 while (c1!=NULL)
  {
   if (strcmp(c1->Name,_ToClient)==0)
    {
     c1->ObjRef->PrintTxt(_txt,_FromClient);
     break;
    }
   c1=c1->Next;
  }
}
