//---------------------------------------------------------------------------

#ifndef ServerServerH
#define ServerServerH
#include "Painter_s.hh"
//---------------------------------------------------------------------------
class ServerImpl: public _sk_TPainter::_sk_Server
{
private:
        //My implementation
        typedef enum
         {
          point, line, rect, circ, fill
         } TElement;
        typedef struct struct_elements
         {
          int x1,y1,x2,y2;
          TElement Type;
          struct struct_elements *Next;
         } TElements;
        typedef struct struct_users
         {
          char Name[25];
          struct struct_users *Next;
         } TUsers;
        typedef struct struct_client
         {
          char Name[25];
          TPainter::Client_ptr ObjRef;
          TUsers *UAnchor,*UActual;
          TElements *EAnchor,*EActual;
          struct struct_client *Next;
         } TClient;
        TClient *Anchor,*Actual;
        int Count;
protected:
public:
        ServerImpl(const char *object_name=NULL);
        CORBA::Long Login(const char* _LogName,
      TPainter::Client_ptr _ObjRef);
        void ClearAll(const char* _LogName);
        void LoadArea(const char* _LogName, const char* _Who);
        void Logout(const char* _LogName);
        void PaintCirc(CORBA::Short _x1, CORBA::Short _y1,
      CORBA::Short _x2, CORBA::Short _y2, const char* _LogName);
        void PaintFill(CORBA::Short _x1, CORBA::Short _y1,
      const char* _LogName);
        void PaintLine(CORBA::Short _x1, CORBA::Short _y1,
      CORBA::Short _x2, CORBA::Short _y2, const char* _LogName);
        void PaintPoint(CORBA::Short _x1, CORBA::Short _y1,
      const char* _LogName);
        void PaintRect(CORBA::Short _x1, CORBA::Short _y1,
      CORBA::Short _x2, CORBA::Short _y2, const char* _LogName);
        void SendTxt(const char* _txt, const char* _ToClient,
      const char* _FromClient);
      //My implementation

};
#endif
