//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <corba.h>
#include "WinPaint.h"
#include "LoginClient.h"
#include "ClientSender.h"
#include "ClientAbout.h"
#include "Area.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TWinClient *WinClient;
//---------------------------------------------------------------------------
__fastcall TWinClient::TWinClient(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


TPainter::Server_ptr __fastcall TWinClient::Getserver(void)
{
        if (Fserver == NULL)
        {
                 Fserver = TPainter::Server::_bind();
        }
        return Fserver;
}

void __fastcall TWinClient::Setserver(TPainter::Server_ptr _ptr)
{
        Fserver = _ptr;
}
void __fastcall TWinClient::FormShow(TObject *Sender)
{
 if (CLogin->ShowModal()==IDOK)
  {
   char cap[50]={0,};
   strcpy(cap,"Painter - ");
   strcat(cap,MyName);
   WinClient->Caption=cap;
   TClientArea *Area=new TClientArea(this);
   Area->Show();
   Area->Caption=MyName;
   if (CountC>1)
    {
     for (int i=0;i<CLogin->ClientsBox->Items->Count;i++)
      {
       if (CLogin->ClientsBox->Checked[i])
        {
         TClientArea *Area=new TClientArea(this);
         Area->Show();
         Area->Caption=CLogin->ClientsBox->Items->Strings[i];
         server->LoadArea(MyName,CLogin->ClientsBox->Items->Strings[i].c_str());
        }
      }
    }
   StatusBar1->Panels->Items[2]->Text="Count of displayed clients: "+
      IntToStr(MDIChildCount);
   StatusBar1->Panels->Items[3]->Text="Count of all clients: "+
      IntToStr(CountC);
  }
}
//---------------------------------------------------------------------------
void __fastcall TWinClient::FormCreate(TObject *Sender)
{
 CountC=0;
 State=0;
 Help.Anchor=NULL;
 Help.Actual=NULL;
}
//---------------------------------------------------------------------------
void THelper::PrintClient(const char* _LogName)
{
 TClient *p1,*p2;
 p1=(TClient *)malloc(sizeof(TClient));
 strcpy(p1->Name,_LogName);
 p1->Next=NULL;
 if (Anchor==NULL) Anchor=p1;
  else
   {
    p2=Anchor;
    while (p2->Next!=NULL) { p2=p2->Next; }
    p2->Next=p1;
   }
 Actual=p1;
}
//---------------------------------------------------------------------------
char *THelper::GetName(int id)
{
 int i=0;
 TClient *pcount;
 pcount=Anchor;
 while (pcount!=NULL)
  {
   if (id==i) return pcount->Name;
   i++;
   pcount=pcount->Next;
  }
 return "Error";
}
//---------------------------------------------------------------------------
void TWinClient::CreateArea(const char *LogName)
{
 TClientArea *Area=new TClientArea(this);
 Area->Show();
 Area->Caption=LogName;
 CountC++;
 StatusBar1->Panels->Items[2]->Text="Count of displayed clients: "+
    IntToStr(MDIChildCount);
 StatusBar1->Panels->Items[3]->Text="Count of all clients: "+
    IntToStr(CountC);
 server->LoadArea(MyName,LogName);
 if (CountC==1)
  {
   Send1->Enabled=false;
   Sendmessage1->Enabled=false;
  }
 else
  {
   Send1->Enabled=true;
   Sendmessage1->Enabled=true;
  }
 State=0;
}
//---------------------------------------------------------------------------
void THelper::RemoveName(const char *LogName)
{
 TClient *c1;
 c1=Anchor;
 while (c1!=NULL)
  {
   if (strcmp(c1->Name,LogName)==0)
    {
     Actual=c1;
     break;
    }
   c1=c1->Next;
  }
 if (Actual==Anchor)
  {
   Anchor=Actual->Next;
   delete(Actual);
   Actual=Anchor;
  }
 else
  {
   c1=Anchor;
   while ((c1!=NULL) && (c1->Next!=Actual)) { c1=c1->Next; }
   c1->Next=Actual->Next;
   delete(Actual);
   Actual=c1;
  }
}
//---------------------------------------------------------------------------
void THelper::AddNewClient(const char* _LogName)
{
 char txt[100]={0,};
 strcpy(txt,"New client [");
 strcat(txt,_LogName);
 strcat(txt,"] login. Show this client ?");
 if (Application->MessageBox(txt,"New login client...", MB_YESNO)==IDYES)
  {
   WinClient->State=1;
   strcpy(WinClient->HName,_LogName);
   PrintClient(_LogName);
  }
}
//---------------------------------------------------------------------------
void TWinClient::ReleaseArea(const char *LogName)
{
 for (int i=0;i<MDIChildCount;i++)
  {
   if (strcmp(MDIChildren[i]->Caption.c_str(),LogName)==0)
    {
     MDIChildren[i]->Close();
     break;
    }
  }
 CountC--;
 if (CountC==1)
  {
   Send1->Enabled=false;
   Sendmessage1->Enabled=false;
  }
 else
  {
   Send1->Enabled=true;
   Sendmessage1->Enabled=true;
  }
 strcpy(HName,LogName);
 State=0;
}
//---------------------------------------------------------------------------
void TWinClient::ReCount(void)
{
 StatusBar1->Panels->Items[2]->Text="Count of displayed clients: "+
    IntToStr(MDIChildCount-1);
 StatusBar1->Panels->Items[3]->Text="Count of all clients: "+
    IntToStr(CountC);
 Help.RemoveName(HName);
 if (CountC==1)
  {
   Send1->Enabled=false;
   Sendmessage1->Enabled=false;
  }
 else
  {
   Send1->Enabled=true;
   Sendmessage1->Enabled=true;
  }
 State=0;
}
//---------------------------------------------------------------------------
void __fastcall TWinClient::FormMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
 if (State==1) CreateArea(HName);
 if (State==2) ReleaseArea(HName);
 if (State==3) ReCount();
}
//---------------------------------------------------------------------------
void THelper::DeleteAll(void)
{
 TClient *c1,*c2;
 c1=Anchor;
 while (c1!=NULL)
  {
   c2=c1->Next;
   delete(c1);
   c1=c2;
  }
}
//---------------------------------------------------------------------------
void __fastcall TWinClient::FormClose(TObject *Sender,
      TCloseAction &Action)
{
 server->Logout(MyName);
 Help.DeleteAll();
}
//---------------------------------------------------------------------------

void __fastcall TWinClient::Logout1Click(TObject *Sender)
{
 Close();
}
//---------------------------------------------------------------------------
void THelper::CloseClient(const char* _LogName)
{
 WinClient->State=2;
 strcpy(WinClient->HName,_LogName);
}
//---------------------------------------------------------------------------


void __fastcall TWinClient::Send1Click(TObject *Sender)
{
 if (CSender->ShowModal()==IDOK)
  {
   server->SendTxt(CSender->Txt->Text.c_str(),CSender->BoxClients->Text.c_str(),
    MyName);
  }
}
//---------------------------------------------------------------------------
void THelper::PrintTxt(const char* _txt,const char* _LogName)
{
 char from[50]={0,};
 char message[256]={0,};
 strcpy(from,"Message from: ");
 strcat(from,_LogName);
 strcpy(message,"Message: ");
 strcat(message,_txt);
 if (Application->MessageBox(message,from, MB_OK)==IDOK) { }
}
//---------------------------------------------------------------------------

void __fastcall TWinClient::About1Click(TObject *Sender)
{
 if (About->ShowModal()==IDOK) {}
}
//---------------------------------------------------------------------------

void __fastcall TWinClient::CLineClick(TObject *Sender)
{
 Line1->Checked=true;
 CLine->Down=true;
 StatusBar1->Panels->Items[1]->Text="Paint: Line";
}
//---------------------------------------------------------------------------

void __fastcall TWinClient::CRectClick(TObject *Sender)
{
 Rectangle1->Checked=true;
 CRect->Down=true;
 StatusBar1->Panels->Items[1]->Text="Paint: Rectangle";
}
//---------------------------------------------------------------------------

void __fastcall TWinClient::CCircClick(TObject *Sender)
{
 Circle1->Checked=true;
 CCirc->Down=true;
 StatusBar1->Panels->Items[1]->Text="Paint: Circle";
}
//---------------------------------------------------------------------------

void __fastcall TWinClient::CFillClick(TObject *Sender)
{
 Fillarea1->Checked=true;
 CFill->Down=true;
 StatusBar1->Panels->Items[1]->Text="Paint: Fill area";
}
//---------------------------------------------------------------------------

void __fastcall TWinClient::CPointClick(TObject *Sender)
{
 Point1->Checked=true;
 CPoint->Down=true;
 StatusBar1->Panels->Items[1]->Text="Paint: Point";
}
//---------------------------------------------------------------------------
char *TWinClient::GetAreaName(void)
{
 char *Name;
 Name=(char *)malloc(30);
 TClientArea *DO=dynamic_cast<TClientArea*>(ActiveMDIChild);
 if (DO)
  {
   strcpy(Name,DO->Caption.c_str());
   return Name;
  }
 return "Error";
}
//---------------------------------------------------------------------------
void TWinClient::PaintElement(int x1,int y1,int x2,int y2,
         int type,const char *name)
{
 for (int i=0;i<MDIChildCount;i++)
  {
   if (strcmp(MDIChildren[i]->Caption.c_str(),name)==0)
    {
     if (type==1)
      {
       MDIChildren[i]->Canvas->MoveTo(x1,y1);
       MDIChildren[i]->Canvas->Pen->Color=clBlue;
       MDIChildren[i]->Canvas->Pen->Width=2;
       MDIChildren[i]->Canvas->LineTo(x1+1,y1+1);
       TClientArea *DO=dynamic_cast<TClientArea*>(MDIChildren[i]);
       if (DO) DO->AddElement(x1,y1,0,0,1);
      }
     if (type==2)
      {
       MDIChildren[i]->Canvas->MoveTo(x1,y1);
       MDIChildren[i]->Canvas->Pen->Color=clBlue;
       MDIChildren[i]->Canvas->Pen->Width=2;
       MDIChildren[i]->Canvas->LineTo(x2,y2);
       TClientArea *DO=dynamic_cast<TClientArea*>(MDIChildren[i]);
       if (DO) DO->AddElement(x1,y1,x2,y2,2);
      }
     if (type==3)
      {
       MDIChildren[i]->Canvas->Pen->Color=clBlue;
       MDIChildren[i]->Canvas->Pen->Width=2;
       MDIChildren[i]->Canvas->Brush->Style=bsClear;
       MDIChildren[i]->Canvas->Rectangle(x1,y1,x2,y2);
       TClientArea *DO=dynamic_cast<TClientArea*>(MDIChildren[i]);
       if (DO) DO->AddElement(x1,y1,x2,y2,3);
      }
     if (type==4)
      {
       MDIChildren[i]->Canvas->Pen->Color=clBlue;
       MDIChildren[i]->Canvas->Pen->Width=2;
       MDIChildren[i]->Canvas->Brush->Style=bsClear;
       MDIChildren[i]->Canvas->Ellipse(x1,y1,x2,y2);
       TClientArea *DO=dynamic_cast<TClientArea*>(MDIChildren[i]);
       if (DO) DO->AddElement(x1,y1,x2,y2,4);
      }
     if (type==5)
      {
       MDIChildren[i]->Canvas->Brush->Color=clBlack;
       MDIChildren[i]->Canvas->Brush->Style=bsSolid;
       MDIChildren[i]->Canvas->FloodFill(x1,y1,clWhite,fsSurface);
       TClientArea *DO=dynamic_cast<TClientArea*>(MDIChildren[i]);
       if (DO) DO->AddElement(x1,y1,0,0,5);
      }
    }
  }
}
//---------------------------------------------------------------------------

void THelper::PaintPoint(CORBA::Short _x1,CORBA::Short _y1,const char* _LogName)
{
 WinClient->PaintElement(_x1,_y1,0,0,1,_LogName);
}
//---------------------------------------------------------------------------
void THelper::PaintRect(CORBA::Short _x1,CORBA::Short _y1,CORBA::Short _x2,
        CORBA::Short _y2,const char* _LogName)
{
 WinClient->PaintElement(_x1,_y1,_x2,_y2,3,_LogName);
}
//---------------------------------------------------------------------------
void THelper::PaintLine(CORBA::Short _x1,CORBA::Short _y1,CORBA::Short _x2,
        CORBA::Short _y2,const char* _LogName)
{
 WinClient->PaintElement(_x1,_y1,_x2,_y2,2,_LogName);
}
//---------------------------------------------------------------------------
void THelper::PaintCirc(CORBA::Short _x1,CORBA::Short _y1,CORBA::Short _x2,
        CORBA::Short _y2,const char* _LogName)
{
 WinClient->PaintElement(_x1,_y1,_x2,_y2,4,_LogName);
}
//---------------------------------------------------------------------------
void THelper::PaintFill(CORBA::Short _x1,CORBA::Short _y1,const char* _LogName)
{
 WinClient->PaintElement(_x1,_y1,0,0,5,_LogName);
}
//---------------------------------------------------------------------------

void __fastcall TWinClient::Tile1Click(TObject *Sender)
{
 Tile();        
}
//---------------------------------------------------------------------------

void __fastcall TWinClient::Cascade1Click(TObject *Sender)
{
 Cascade();        
}
//---------------------------------------------------------------------------

void __fastcall TWinClient::CClearClick(TObject *Sender)
{
 TClientArea *DO=dynamic_cast<TClientArea*>(ActiveMDIChild);
 if (DO)
  {
   TRect R(0,0,DO->Width,DO->Height);
   DO->Canvas->Brush->Color=clWhite;
   DO->Canvas->Brush->Style=bsSolid;
   DO->Canvas->FillRect(R);
   server->ClearAll(DO->Caption.c_str());
   DO->ClearElement();
  }
}
//---------------------------------------------------------------------------
void TWinClient::ClearAllElements(const char *Name)
{
 for (int i=0;i<MDIChildCount;i++)
  {
   if (strcmp(MDIChildren[i]->Caption.c_str(),Name)==0)
    {
     TRect R(0,0,MDIChildren[i]->Width,MDIChildren[i]->Height);
     MDIChildren[i]->Canvas->Brush->Color=clWhite;
     MDIChildren[i]->Canvas->Brush->Style=bsSolid;
     MDIChildren[i]->Canvas->FillRect(R);
     TClientArea *DO=dynamic_cast<TClientArea*>(MDIChildren[i]);
     if (DO) DO->ClearElement();
    }
  }
}
//---------------------------------------------------------------------------
void THelper::ClearAll(const char* _LogName)
{
 WinClient->ClearAllElements(_LogName);
}
//---------------------------------------------------------------------------


