//---------------------------------------------------------------------------

#ifndef WinPaintH
#define WinPaintH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "Painter_c.hh"
#include "Painter_s.hh"
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
#include <ImgList.hpp>
//---------------------------------------------------------------------------
class THelper : public _sk_TPainter::_sk_Client
{
private:
public:
        //My implementation
        typedef struct struct_clients
         {
          char Name[25];
          struct struct_clients *Next;
         } TClient;
        TClient *Anchor,*Actual;
        char *GetName(int id);
        void RemoveName(const char *LogName);
        void DeleteAll(void);
        //Corba
  void PaintRect(CORBA::Short _x1,CORBA::Short _y1,CORBA::Short _x2,
        CORBA::Short _y2,const char* _LogName);
  void PaintLine(CORBA::Short _x1,CORBA::Short _y1,CORBA::Short _x2,
        CORBA::Short _y2,const char* _LogName);
  void PaintCirc(CORBA::Short _x1,CORBA::Short _y1,CORBA::Short _x2,
        CORBA::Short _y2,const char* _LogName);
  void PaintPoint(CORBA::Short _x1,CORBA::Short _y1,const char* _LogName);
  void PaintFill(CORBA::Short _x1,CORBA::Short _y1,const char* _LogName);
  void ClearAll(const char* _LogName);
  void AddNewClient(const char* _LogName);
  void PrintClient(const char* _LogName);
  void PrintTxt(const char* _txt,const char* _LogName);
  void CloseClient(const char* _LogName);
};
//---------------------------------------------------------------------------
class TWinClient : public TForm
{
__published:	// IDE-managed Components
        TStatusBar *StatusBar1;
        TMainMenu *MainMenu1;
        TToolBar *ToolBar1;
        TMenuItem *Logout1;
        TMenuItem *Paint1;
        TMenuItem *Point1;
        TMenuItem *Line1;
        TMenuItem *Rectangle1;
        TMenuItem *Circle1;
        TMenuItem *Fillarea1;
        TMenuItem *N1;
        TMenuItem *Clearall1;
        TMenuItem *Sendmessage1;
        TMenuItem *Users1;
        TMenuItem *Tile1;
        TMenuItem *Cascade1;
        TMenuItem *About1;
        TImageList *ImageList1;
        TToolButton *CPoint;
        TToolButton *CLine;
        TToolButton *CRect;
        TToolButton *CCirc;
        TToolButton *CFill;
        TToolButton *ToolButton6;
        TToolButton *CClear;
        TToolButton *Send1;
        TToolButton *ToolButton9;
        TToolButton *ToolButton10;
        TToolButton *ToolButton11;
        void __fastcall FormShow(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall Logout1Click(TObject *Sender);
        void __fastcall Send1Click(TObject *Sender);
        void __fastcall About1Click(TObject *Sender);
        void __fastcall CLineClick(TObject *Sender);
        void __fastcall CRectClick(TObject *Sender);
        void __fastcall CCircClick(TObject *Sender);
        void __fastcall CFillClick(TObject *Sender);
        void __fastcall CPointClick(TObject *Sender);
        void __fastcall Tile1Click(TObject *Sender);
        void __fastcall Cascade1Click(TObject *Sender);
        void __fastcall CClearClick(TObject *Sender);
private:	// User declarations
        TPainter::Server_ptr __fastcall Getserver();
        TPainter::Server_var Fserver;
        void __fastcall Setserver(TPainter::Server_ptr _ptr);
public:		// User declarations
        THelper Help;
        int CountC;
        int State;
        char MyName[20];
        char HName[20];
        void CreateArea(const char *LogName);
        void ReleaseArea(const char *LogName);
        char *GetAreaName(void);
        void PaintElement(int x1,int y1,int x2,int y2,
         int type,const char *name);
        void ClearAllElements(const char *Name);
        void ReCount(void);
        __fastcall TWinClient(TComponent* Owner);
        __property TPainter::Server_ptr server = {read=Getserver, write=Setserver};
};
//---------------------------------------------------------------------------
extern PACKAGE TWinClient *WinClient;
//---------------------------------------------------------------------------
#endif
